/*
 * Part of upcompiler. Copyright (c) 2012, Urs Fässler, Licensed under the GNU Genera Public License, v3
 * @author: urs@bitzgi.ch
 */

package ast.expression;

public enum CompareOp {
	EQUAL, NOT_EQUAL,
	LOWER_EQUAL, GREATER_EQUAL, LOWER, GREATER;

	@Override
	public String toString() {
		switch(this){
		case EQUAL: return "==";
		case NOT_EQUAL: return "!=";
		case LOWER_EQUAL: return "<=";
		case GREATER_EQUAL: return ">=";
		case LOWER: return "<";
		case GREATER: return ">";
		default: throw new RuntimeException( "Not yet implemneted: " + this.ordinal() );
		}
	}

  public CompareOp getInverse() {
    switch(this){
    case EQUAL: return NOT_EQUAL;
    case NOT_EQUAL: return EQUAL;
    case LOWER_EQUAL: return GREATER;
    case GREATER_EQUAL: return LOWER;
    case LOWER: return GREATER_EQUAL;
    case GREATER: return LOWER_EQUAL;
    default: throw new RuntimeException( "Not yet implemneted: " + this.ordinal() );
    }
  }
}
