/*
 * Part of upcompiler. Copyright (c) 2012, Urs Fässler, Licensed under the GNU Genera Public License, v3
 * @author: urs@bitzgi.ch
 */

package cfg;

public enum IrType {
  IntegerExpr, CompareExpr, UnaryExpr, IfExpr, VariableRefLinked, VariableRefUnlinked, VariableRefKilled, CallExprLinked, CallExprUnlinked, CallExprPointer,
  PhiStmt, AssignmentStmt, JumpStmt, NopStmt, RetStmt, 
  Memory, Variable, IntConstant, BooleanConstant,
  FuncLibrary, FuncProgram, FuncSystem,
  BasicBlock, 
  VariablePtrDeref, VariablePtrOf, 
  VariableArray, Array;

  public boolean isData() {
    switch (this) {
      case Memory:
      case Variable:
      case IntConstant:
      case BooleanConstant:
        return true;
      default:
        return false;
    }
  }

  public boolean isExpression() {
    switch (this) {
      case IntegerExpr:
      case CallExprLinked:
      case CallExprUnlinked:
      case CallExprPointer:
      case CompareExpr:
      case UnaryExpr:
      case IfExpr:
      case VariableRefKilled:
      case VariableRefLinked:
      case VariableRefUnlinked:
      case Variable:
      case IntConstant:
      case BooleanConstant:
        return true;
      default:
        return false;
    }
  }

  public boolean isStatement() {
    switch (this) {
      case PhiStmt:
      case AssignmentStmt:
      case JumpStmt:
      case NopStmt:
      case RetStmt:
        return true;
      default:
        return false;
    }
  }
}
