package disassembler.diStorm3;

import cfg.variable.VariableName;

public enum Registers implements VariableName{
	RAX, RCX, RDX, RBX, RSP, RBP, RSI, RDI, R8, R9, R10, R11, R12, R13, R14, R15,
	EAX, ECX, EDX, EBX, ESP, EBP, ESI, EDI, R8D, R9D, R10D, R11D, R12D, R13D, R14D, R15D,
	AX, CX, DX, BX, SP, BP, SI, DI, R8W, R9W, R10W, R11W, R12W, R13W, R14W, R15W,
	AL, CL, DL, BL, AH, CH, DH, BH, R8B, R9B, R10B, R11B, R12B, R13B, R14B, R15B,
	SPL, BPL, SIL, DIL,
	ES, CS, SS, DS, FS, GS,
	RIP,
	ST0, ST1, ST2, ST3, ST4, ST5, ST6, ST7,
	MM0, MM1, MM2, MM3, MM4, MM5, MM6, MM7,
	XMM0, XMM1, XMM2, XMM3, XMM4, XMM5, XMM6, XMM7, XMM8, XMM9, XMM10, XMM11, XMM12, XMM13, XMM14, XMM15,
	YMM0, YMM1, YMM2, YMM3, YMM4, YMM5, YMM6, YMM7, YMM8, YMM9, YMM10, YMM11, YMM12, YMM13, YMM14, YMM15,
	CR0, UNUSED0, CR2, CR3, CR4, UNUSED1, UNUSED2, UNUSED3, CR8,
	DR0, DR1, DR2, DR3, UNUSED4, UNUSED5, DR6, DR7;
	
    static public Registers getDisplacementReg( int index ){
		return Registers.values()[DS.ordinal()+index];		//TODO check if correct for all registers
	}
    
    static public Registers getRegisterByIndex( int index ){
//    	assert( index <= R15B.ordinal() );
    	return Registers.values()[index];
    }
    
    public boolean isMmx(){
      switch( this ){
        case MM0: case MM1: case MM2: case MM3: case MM4: case MM5: case MM6: case MM7:
        case XMM0: case XMM1: case XMM2: case XMM3: case XMM4: case XMM5: case XMM6: case XMM7:
        case XMM8: case XMM9: case XMM10: case XMM11: case XMM12: case XMM13: case XMM14: case XMM15:
        case YMM0: case YMM1: case YMM2: case YMM3: case YMM4: case YMM5: case YMM6: case YMM7:
        case YMM8: case YMM9: case YMM10: case YMM11: case YMM12: case YMM13: case YMM14: case YMM15:
          return true;
        default:
          return false;
      }
    }

    public boolean onlyLocalScope() {
      return false;
    }
};
